// Cat's Eye BBS Ad
// BBS Ads v4.1 for Windows
// Steven Lawrance

#include <windowsx.h>
#include <mmsystem.h>
#include <string.h>
#include <256color.h>
#include "catseye.h"
#include "..\bbsads.h"

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
				     WPARAM wParam, LPARAM lParam);
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
		              WPARAM wParam, LPARAM lParam);
void WMCommand_Handler(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify);
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl,
                          UINT codeNotify);
HBITMAP     hBitmap;
HPALETTE    hPalette;
static char Buffer[9];

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdParam, int nCmdShow)
{
   char        ProgName[] = "BBS Ads v4.1";
   HWND        hWnd;
   MSG         msg;
   HMENU       hMenu;

   if (!hPrevInstance)
   {
      WNDCLASS    wndclass;

      wndclass.style         = CS_VREDRAW | CS_HREDRAW;
      wndclass.lpfnWndProc   = (WNDPROC) MainWndProc;
      wndclass.hInstance     = hInstance;
      wndclass.hIcon         = LoadIcon (wndclass.hInstance, "CATWIN");
      wndclass.hCursor       = LoadCursor (wndclass.hInstance, "KITTYCAT");
      wndclass.lpszMenuName  = "MAIN";
      wndclass.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
      wndclass.lpszMenuName  = NULL;
      wndclass.cbClsExtra    = 0;
      wndclass.cbWndExtra    = 0;
      wndclass.lpszClassName = ProgName;

      RegisterClass(&wndclass);
   }


   ghInstance = hInstance;

   hWnd = CreateWindow(ProgName,"Cat's Eye BBS Ad",    
		       WS_OVERLAPPED | WS_SYSMENU | WS_MINIMIZEBOX,
                       CW_USEDEFAULT, CW_USEDEFAULT,          
                       492, 390,          
                       NULL, NULL, hInstance, NULL);

   hMenu = LoadMenu(ghInstance, "MAIN");
   SetMenu(hWnd, hMenu);
   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   while (GetMessage(&msg, NULL, 0, 0))
   {
      TranslateMessage(&msg);
      DispatchMessage(&msg);
   }
   return msg.wParam;
}

LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                     WPARAM wParam, LPARAM lParam)
{
   switch (message)
   {
      case WM_CREATE :
      {
        mciSendString ((LPSTR)"open cats.wav alias catseye", Buffer, 80, NULL);
	mciSendString ((LPSTR)"play catseye from 1", Buffer, 80, NULL);
	hBitmap = GetPic256(hWnd, "CatseyeBmp");
	hPalette = GetPicPal();
	return 0;
      }
      case WM_SETFOCUS :
      {
	if (hBitmap)
          RefreshPicPal(hWnd, hPalette);
      }
      case WM_PAINT :
      {
        if (hBitmap)
	  RefreshPicture(hWnd, hBitmap, hPalette, 0, 0, 0, 0, 490, 350);
	return 0;
      }
      case WM_RBUTTONDOWN :
      {
	mciSendString ((LPSTR)"play catseye from 1", NULL, 80, NULL);
	MessageBox(hWnd, "Meow!!", "Cat's Eye BBS Message", MB_OK | MB_ICONASTERISK);
        return 0;
      }
      case WM_LBUTTONDOWN :
      {
	MessageBeep(MB_ICONASTERISK);
	MessageBox(hWnd, "If you are like many people, you want a BBS without a registration fee.  Well, the Cat's Eye BBS is for YOU!!", "Cat's Eye BBS Ad Factoid", MB_OK | MB_ICONASTERISK);
	return 0;
      }
      case WM_DESTROY :
      {
	DeletePic(hBitmap);
	DeletePal(hPalette);
	DeleteObject(hBitmap);
        DeleteObject(hPalette);
        mciSendString ((LPSTR)"close catseye", NULL, 80, NULL);
	PostQuitMessage(0);
        return 0;
      }
      case WM_COMMAND :
      {
	return HANDLE_WM_COMMAND(hWnd, wParam, lParam, WMCommand_Handler);
      }
   }
   return DefWindowProc (hWnd, message, wParam, lParam);
}

#pragma argused
BOOL CALLBACK _export DlgProc(HWND hDlg, UINT message,
	                      WPARAM wParam, LPARAM lParam)
{
   switch(message)
   {
      case WM_INITDIALOG :
      {
         int i;
 	 mciSendString ((LPSTR)"play catseye from 1", Buffer, 80, NULL);
	 for (i=2; i<=7; i++)
	 {
           GetBBSAdsStringTitles(hDlg, ghInstance, i);
	 }
	 return TRUE;
      }

      case WM_COMMAND :
      {
	 return (BOOL)HANDLE_WM_COMMAND(hDlg, wParam, lParam,
	                                WMDlgCommand_Handler);
      }
   }

   return FALSE;
}

#pragma argsused
void WMCommand_Handler(HWND hWnd, int id, HWND hwndCtl, UINT codeNotify)
{
   switch (id)
   {
      case CM_ASTERISK :
      {
	MessageBeep(MB_ICONASTERISK);
	break;
      }
      case CM_EXCLAMATION :
      {
	MessageBeep(MB_ICONEXCLAMATION);
	break;
      }
      case CM_QUESTION :
      {
       	MessageBeep(MB_ICONQUESTION);
	break;
      }
      case CM_STOP :
      {
	MessageBeep(MB_ICONSTOP);
	break;
      }
      case CM_MEOW :
      {
        mciSendString ((LPSTR)"play catseye from 1", Buffer, 80, NULL);
	break;
      }
      case CM_ABOUT :
      {
        DLGPROC AbtDlgProc;

        AbtDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, ghInstance);
        DialogBox(ghInstance, "ABOUT", hWnd, AbtDlgProc);
        FreeProcInstance((FARPROC)AbtDlgProc);
        InvalidateRect(hWnd, NULL, TRUE);
        break;
      }
      case CM_EXIT2 :
      {
	DestroyWindow(hWnd);
	break;
      }
    }
}

#pragma argsused
void WMDlgCommand_Handler(HWND hDlg, int id, HWND hwndCtl, UINT codeNotify)
{
   switch(id)
   {
      case ID_ABOUTOK :
      {
        mciSendString ((LPSTR)"stop catseye", NULL, 0, NULL);
	EndDialog(hDlg, 0);
	break;
      }
      case ID_ABOUTPUSH :
      {
	MessageBeep(MB_ICONASTERISK);
	MessageBox(hDlg, "This program is free to distribute.  Since this is an ad, we encourage it.  The picture was created with the help of other pictures and the program was written by Steven Lawrance in 1994 with C++ 3.1 for Windows by Borland (1992).  This ad operates in Win3.1 Standard/386 Modes Only.  The picture requires a minimum of 16 colors.  If your driver is 2 colors, you're out of luck!  --Steven Lawrance--", "Information On The Program", MB_OK | MB_ICONASTERISK);
	mciSendString ((LPSTR)"play catseye from 1", Buffer, 80, NULL);
	break;
      }
      case ID_DEF :
      {
	codeNotify = LBN_DBLCLK;
      }
      case ID_LISTBOX :
      {
       if ( codeNotify == LBN_DBLCLK )
       {
	char szBuf[20];
	char Text[300];
	DWORD dwIndex;

	dwIndex = SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETCURSEL, 0, 0);
        if (dwIndex != LB_ERR)
	{
          int i;
          char TextTmp[310];
	  SendDlgItemMessage(hDlg, ID_LISTBOX, LB_GETTEXT, (WPARAM) dwIndex, (LPARAM) ((LPSTR) szBuf));
	  for (i=51; i<=77; i++)
          {
            LoadString(ghInstance, i, Text, 300);
	    if (strcmp(Text, "") != 0)
            {
	      strcpy(TextTmp, " ");
	      strcat(TextTmp, Text);
	      if (strcmp(szBuf, TextTmp) == 0)
	      {
		LoadString(ghInstance, i+1, Text, 300);
		MessageBox(hDlg, Text, "Information On The BBS", MB_OK | MB_ICONASTERISK);
	      }
	    }
	    i = i+1;
	  }
	  for (i=1; i<=7; i++)
          {
	    LoadString(ghInstance, i, Text, 300);
	    if (strcmp(szBuf, Text) == 0)
	    {
	      GetDefaultData(hDlg, ghInstance, szBuf, "Information On The BBS");
	    }
          }
	  };
	if (dwIndex == LB_ERR)
	{
	  SendDlgItemMessage(hDlg, ID_LISTBOX, LB_SELECTSTRING, -1, (LPARAM) ((LPSTR) "Programmers:"));
	};
       }
       break;
      }
   }
}
